/*
************************************************************************
*           All Copyright Reserved!                                    *
*                                                                      *
*  Prog:    database                                                   *
*  Version: version 1.0                                                *
*  Author:  Junmei Wang                                                *
*                                                                      *
*  Department of Pharmaceutical Chemistry                              *
*  School of Pharmacy                                                  *
*  University of California                                            *
*  San Francisco   CA 94143                                            *
*  Octomber, 2001                                                      *
************************************************************************
*/

# include "common.h"
# include "define.h" 
# define MAXCOMMAND 20
# define debug 1 
FILE *fpin;
FILE *fpout;
FILE *fperror;
FILE *fpprocess;

char ifilename[MAXCHAR];
char dfilename[MAXCHAR];
char separator[MAXCHAR];
char rbegin[MAXCHAR];
char rend[MAXCHAR];
char def[MAXCHAR];
char field[MAXCHAR];
char command[MAXCOMMAND][MAXCHAR];
char tmp_file[MAXCHAR] = "TMP";
char molname[MAXCHAR];
char rmolname[MAXCHAR];
int i, j, k;
int ncom = 0;
int id = 1;
int flag = 1;
int separator_index = 0;
int rbegin_index = 0;
int rend_index = 0;
int def_index = 0;
int field_index = 0;
long cmpd_num = 0;

void newitoa(long num, char *str)
{
        int i = 0;
        int j;
        long tmpint, mod;
        char tmpchar[MAXCHAR];
        strcpy(str, "");
        while (num >= 10) {
                tmpint = num / 10;
                mod = num - tmpint * 10;
                switch (mod) {
                case 0:
                        tmpchar[i] = '0';
                        break;
                case 1:
                        tmpchar[i] = '1';
                        break;
                case 2:
                        tmpchar[i] = '2';
                        break;
                case 3:
                        tmpchar[i] = '3';
                        break;
                case 4:
                        tmpchar[i] = '4';
                        break;
                case 5:
                        tmpchar[i] = '5';
                        break;
                case 6:
                        tmpchar[i] = '6';
                        break;
                case 7:
                        tmpchar[i] = '7';
                        break;
                case 8:
                        tmpchar[i] = '8';
                        break;
                case 9:
                        tmpchar[i] = '9';
                        break;
                }
                i++;
                num = tmpint;
        }
        switch (num) {
        case 0:
                tmpchar[i] = '0';
                break;
        case 1:
                tmpchar[i] = '1';
                break;
        case 2:
                tmpchar[i] = '2';
                break;
        case 3:
                tmpchar[i] = '3';
                break;
        case 4:
                tmpchar[i] = '4';
                break;
        case 5:
                tmpchar[i] = '5';
                break;
        case 6:
                tmpchar[i] = '6';
                break;
        case 7:
                tmpchar[i] = '7';
                break;
        case 8:
                tmpchar[i] = '8';
                break;
        case 9:
                tmpchar[i] = '9';
                break;
        }
        i++;
        for (j = 0; j < i; j++)
                str[j] = tmpchar[i - j - 1];
        str[i] = '\0';
        /*   printf("\n %5d",i);
           printf("\n %s", tmpchar);
           printf("\n %s", str); */
}

int runcommand(char *commandstr)
{
	int i;
	int status = 0;
	char realcommand[MAXCHAR] = "";
	char tmpchar[2];
	for (i = 0; i < strlen(commandstr); i++) {
		if (i < strlen(commandstr) - 6) {
			if (commandstr[i] == 'T' && commandstr[i + 1] == 'M'
				&& commandstr[i + 2] == 'P' && commandstr[i + 3] == 'F'
				&& commandstr[i + 4] == 'I' && commandstr[i + 5] == 'L'
				&& commandstr[i + 6] == 'E') {
				strcat(realcommand, tmp_file);
				i += 7;
			}
			if (commandstr[i] == 'M' && commandstr[i + 1] == 'O'
				&& commandstr[i + 2] == 'L' && commandstr[i + 3] == 'N'
				&& commandstr[i + 4] == 'A' && commandstr[i + 5] == 'M'
				&& commandstr[i + 6] == 'E') {
				strcat(realcommand, molname);
				i += 7;
			}
		}
		tmpchar[0] = commandstr[i];
		tmpchar[1] = '\0';
		strcat(realcommand, tmpchar);
	}
	status = system(realcommand);
	if(status != 0) {
		fprintf(fperror, "\nNo: %-8ld, Molecualr Name = %s\n", cmpd_num, molname);
		fprintf(fperror, "Error: cannot run \"%s\" in runcommand() of database.c properly, exit\n", realcommand);
		fflush(fperror);
		return 1;
	}
	return 0;
}

void rdef(char *filename)
{
	int num_command = 0;
	int index;
	int num;
	int num_quota; 
	char line[MAXCHAR];
	FILE *fpin;

	if ((fpin = fopen(filename, "r")) == NULL) {
		printf("\n Cannot open defintion file %s , exit", filename);
		exit(0);
	}
	i = 0;
	for (;;) {
		if (fgets(line, MAXCHAR, fpin) == NULL)
			break;
		if (strncmp("SEPARATOR", line, 9) == 0) {
			index = 0;
			num_quota =0 ;
			k = 0;
			separator_index = 1;
			for (j = 9; j < strlen(line); j++) {
				if(line[j] =='\"') num_quota ++;
				if(index ==0 && num_quota == 1) {
					index = 1;
					continue;
				}	
				if(num_quota == 2) {
					separator[k] = '\0';
					break;
				}	
				if (index == 1) {
					separator[k] = line[j];
					k++;
				}
			}
		}
		if (strncmp("RECORD_BEGIN", line, 12) == 0) {
			index = 0;
			k = 0;
                        num_quota =0 ;
			rbegin_index = 1;
			rbegin[0]='\0';
                       	for (j = 12; j < strlen(line); j++) {
                                if(line[j] =='\"') num_quota ++;
				if(index ==0 && num_quota == 1) {
                                	index = 1;
                                	continue;
                        	}
                        	if(num_quota == 2) {
                                	rbegin[k] = '\0';
                                	break;
                        	} 
                        	if (index == 1) { 
                                	rbegin[k] = line[j];
                                	k++;
                        	}
			}
                }

		if (strncmp("RECORD_END", line, 10) == 0) {
			index = 0;
			k = 0;
                        num_quota =0 ;
                        rend_index = 1;
                        rend[0]='\0';
                        for (j = 10; j < strlen(line); j++) {
                                if(line[j] =='\"') num_quota ++;
                        	if(index == 0 && num_quota == 1) {
                                	index = 1;
                                	continue;
                        	}
                        	if(num_quota == 2) {
                                	rend[k] = '\0';
                                	break;
                        	} 
                        	if (index == 1) { 
                                	rend[k] = line[j];
                                	k++;
                        	}
                	}
		}
		if (strncmp("MOLNAME_DEF", line, 11) == 0) {
			sscanf(&line[11], "%s", def);
			def_index = 1;
			continue;
		}
		if (strncmp("MOLNAME_ID", line, 10) == 0) {
			sscanf(&line[10], "%d", &id);
			continue;
		}
		if (strncmp("TMPFILE", line, 7) == 0) {
			sscanf(&line[7], "%s", tmp_file);
			continue;
		}
		if (strncmp("MOLNAME_FIELD", line, 13) == 0) {
			index = 0;
			k = 0;
                        num_quota =0 ;
                        field_index = 1;
                        field[0]='\0';
                        for (j = 13; j < strlen(line); j++) {
                                if(line[j] =='\"') num_quota ++;
                        	if(index == 0 && num_quota == 1) {
                                	index = 1;
                                	continue;
                        	}
                        	if(num_quota == 2) {
                                	field[k] = '\0';
                                	break;
                        	} 
                        	if (index == 1) { 
                                	field[k] = line[j];
                                	k++;
                        	}
			}
                }
		if (strncmp("MOLNAME_READ_FLAG", line, 17) == 0) {
			sscanf(&line[17], "%d", &flag);
			continue;
		}
		if (strncmp("COMMAND", line, 7) == 0) {
			index = 0;
			k = 0;
                        num = 0;
                        num_quota =0 ;
                        for (j = 7; j < strlen(line); j++)
                                if(line[j] =='\"') num_quota ++;
                        for (j = 7; j < strlen(line); j++) {
                                if (line[j] == '\"') {
                                        num++;
                                        if (index == 0) {
                                                index = 1;
                                                continue;
                                        }
                                        if(num == num_quota && index ==1) {
                                                index =2;
                                                command[num_command][k] = '\0';
                                        }
                                }
                                if (index == 1) {
                                        command[num_command][k] = line[j];
                                        k++;
                                }
                        }
			num_command++;	
		        if (num_command > MAXCOMMAND) {
                        	printf
                                	("\nError: the number of commands exceed MAXCOMMAND, increase MAXCOMMAND, exit");
                        	exit(0);
                	}
                        continue;
                }
	}

	ncom = num_command;
	fclose(fpin);

	if (rbegin_index == 0 || rend_index == 0) {
		rbegin_index = 0;
		rend_index = 0;
	}
	if (rbegin_index == 1 && rend_index == 1) 
		separator_index = 0;
	if (separator_index == 0 && rbegin_index == 0 && rend_index == 0) {
		printf("\nNo Separation Field, exit\n");
		exit(0);
	}
	if (def_index == 1) 
		field_index = 0;
	if (def_index == 0 && field_index == 0) {
		printf("\nNo Molecular Name, exit\n");
		exit(0);
	}
	if(debug) {
		if(rbegin_index ==1) printf("\nRecord Begin String = %s", rbegin);
		if(rend_index ==1) printf("\nRecord End String = %s", rend);
		if(separator_index ==1) printf("\nRecord Separator = %s", separator);
		if(def_index ==1) printf("\nMolname Defined %s", def);
		if(field_index ==1) printf("\nMolname Field = %s and Molname Read Flag = %d", field, flag);
		printf("\nTmp_file = %s", tmp_file);
		printf("\nId = %d", id);
		printf("\nNo of Commands = %d", ncom);
		for(i=0;i<ncom;i++)
			printf("\nCommand (%d) =  %s", i+1, command[i]);
		printf("\n");	
	}
}
void rdatabase(char *filename)
{
	int i;
	int begin_flag;
	int write_flag;
	int status;
	char line[MAXCHAR] = "";
	char linebak[MAXCHAR];
	char tmpchar[MAXCHAR];
	FILE *fpin;
	FILE *fptmp;

	if ((fpin = fopen(filename, "r")) == NULL) {
		printf("\n Cannot open defintion file %s , exit", filename);
		exit(0);
	}
	cmpd_num = 0;
	begin_flag = 0;
	write_flag = 0;
	for (;;) {
		strcpy(linebak, line);
		if (fgets(line, MAXCHAR, fpin) == NULL) {
			fclose(fptmp);
			if (separator_index == 1) {
				if(def_index == 1) {
					strcpy(molname, def);
					newitoa(id - 1, tmpchar);
					strcat(molname, tmpchar);
				}
				if (field_index == 1)
					strcpy(molname, rmolname);
				printf("\nProcessing: %-8ld id=%7d, comp. name = %s\n", cmpd_num, id - 1, molname);
				fflush(stdout);
				fprintf(fpprocess, "\nProcessing: %-8ld id=%7d, comp. name = %s\n", cmpd_num, id - 1, molname);
				fflush(fpprocess);
/*run commands */
				for (i = 0; i < ncom; i++) {
					status = runcommand(command[i]);
					if(status == 1) 
						break; 
/*if error happens, stop running*/
				}
			}
			break;
		}
		if (separator_index == 1) {
			if (strstr(line, separator) != 0) {
				if (begin_flag != 0) {
					write_flag = 0;
					fclose(fptmp);
					if(def_index == 1) {
						strcpy(molname, def);
						newitoa(id - 1, tmpchar);
						strcat(molname, tmpchar);
					}
					if (field_index == 1)
						strcpy(molname, rmolname);
					printf("\nProcessing: %-8ld id=%7d, comp. name = %s", cmpd_num, id - 1, molname);
					fflush(stdout);
					fprintf(fpprocess, "\nProcessing: %-8ld id=%7d, comp. name = %s", cmpd_num, id - 1, molname);
					fflush(fpprocess);
/*run commands */
					for (i = 0; i < ncom; i++) {
						status = runcommand(command[i]);
						if(status == 1) 
							break; 
					}
/*if error happens, stop running*/
				}
				if (begin_flag == 0)
					begin_flag = 1;
				if ((fptmp = fopen(tmp_file, "w")) == NULL) {
					printf("\n Cannot open file %s ,exit", tmp_file);
					exit(0);
				}
				id++;
				fprintf(fptmp, "%s", line);
				write_flag = 1;
				cmpd_num++;
				continue;
			}
		}
		if (rbegin_index == 1 && rend_index == 1) {
			if (strstr(line, rbegin) != 0) {
				if ((fptmp = fopen(tmp_file, "w")) == NULL) {
					printf("\n Cannot open file %s ,exit", tmp_file);
					exit(0);
				}
				id++;
				fprintf(fptmp, "%s", line);
				write_flag = 1;
				cmpd_num++;
				continue;
			}
			if (strstr(line, rend) != 0) {

				write_flag = 0;
				fprintf(fptmp, "%s", line);
				fclose(fptmp);
				if (def_index == 1) {
					strcpy(molname, def);
					newitoa(id - 1, tmpchar);
					strcat(molname, tmpchar);
				}
				if (field_index == 1)
					strcpy(molname, rmolname);
				printf("\nProcessing: %-8ld id=%7d, comp. name = %s", cmpd_num, id - 1, molname);
				fflush(stdout);
				fprintf(fpprocess, "\nProcessing: %-8ld id=%7d, comp. name = %s", cmpd_num, id - 1, molname);
				fflush(fpprocess);
/*run commands */
				for (i = 0; i < ncom; i++) {
					status = runcommand(command[i]);
					if(status == 1) 
						break; 
/*if error happens, stop running*/
				}
				continue;
			}
		}
		if (write_flag == 1)
			fprintf(fptmp, "%s", line);
		if (field_index == 1 && strstr(line, field) != 0) {
			if (flag == -1) {
				sscanf(linebak, "%s", rmolname);
				continue;
			}
			if (flag ==  0) {
				sscanf(line, "%s", rmolname);
				continue;
			}
			if (flag == 1) {
				if (fgets(line, MAXCHAR, fpin) == NULL)
					break;
				sscanf(line, "%s", rmolname);
				continue;
			}
		}

	}
}

int main(int argc, char *argv[])
{
	int i;


	if (strcmp(COLORTEXT, "YES") == 0 || strcmp(COLORTEXT, "yes") == 0) {
		if (argc == 2
			&& (strcmp(argv[1], "-h") == 0
				|| strcmp(argv[1], "-H") == 0)) {
			printf("[31mUsage: database -i[0m database file name\n"
				   "[31m                -d[0m definition file name\n");
			exit(0);
		}
		if (argc != 5) {
			printf("[31mUsage: database -i[0m database file name\n"
				   "[31m                -d[0m definition file name\n");
			exit(0);
		}
	} else {
		if (argc == 2
			&& (strcmp(argv[1], "-h") == 0
				|| strcmp(argv[1], "-H") == 0)) {
			printf("Usage: database -i database file name\n"
				   "                -d definition file name\n");
			exit(0);
		}
		if (argc != 5) {
			printf("Usage: database -i database file name\n"
				   "                -d definition file name\n");
			exit(0);
		}

	}

	for (i = 1; i < argc; i += 2) {
		if (strcmp(argv[i], "-i") == 0)
			strcpy(ifilename, argv[i + 1]);
		if (strcmp(argv[i], "-d") == 0)
			strcpy(dfilename, argv[i + 1]);
	}
	if ((fperror = fopen("error.log", "w")) == NULL) {
		printf("\n Cannot open fiel \"error.log\", exit\n");
		exit(0);
	}
	if ((fpprocess = fopen("process.log", "w")) == NULL) {
		printf("\n Cannot open fiel \"process.log\", exit\n");
		exit(0);
	}
	rdef(dfilename);
	rdatabase(ifilename);
	fclose(fperror);
	fclose(fpprocess);
	printf("\n"); 
	return (0);
}
